%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
function [list lcount]= ComputeGHT2(cand, peaks, pic)
    global s1 s2 gap1 gap2 th_min_blk;
    
    [list lcount] = ComputeGHT_AllMotif(cand,peaks,pic);
    %%[list lcount] = ComputeGHT_Top1(cand,peaks,pic);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
function [list lcount]= ComputeGHT_Top1(cand, peaks, pic)
    global s1 s2 gap1 gap2 th_min_blk;    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Compute GHT on Candidate %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    num_cand = size(cand,1);
    lc = 0; bc1=0; bc2=0; show_err=0;
    list = zeros(num_cand,6);
    bsf = intmax;
    ght_count = 0; 
    c1=0; c2=0;
    for i=1:num_cand
        a=cand(i,1);
        b=cand(i,2);
        if ((a==0)||(b==0)),      continue;       end
        x1 = peaks(a,1);
        y1 = peaks(a,2);
        x2 = peaks(b,1);
        y2 = peaks(b,2);
        if ((peaks(a,3) <th_min_blk) || (peaks(b,3) <th_min_blk))
            bc2 = bc2+1;
            continue;
        end
        if ((abs(x1-x2)<=gap1)&&(abs(y1-y2)<=gap2))
            bc1 = bc1+1;
            continue;
        end
        
        lb = ght_lb(pic(x1:x1+s1-1, y1:y1+s2-1) , pic(x2:x2+s1-1,y2:y2+s2-1),peaks(a,3), peaks(b,3));
        if (lb > bsf)
            continue;
        end
            
        ght_count = ght_count+1;
        true_dist = ght3(pic(x1:x1+s1-1, y1:y1+s2-1) , pic(x2:x2+s1-1,y2:y2+s2-1), peaks(a,3), peaks(b,3));
        true_dist = round(true_dist);
        if (bsf > true_dist)
            bsf = true_dist;
            lc = 1;
        % % list => BSF, x1, y1, x2, y2, #hit
            list(lc,:) = [true_dist x1 y1 x2 y2 cand(i,3)]; 
        end
        if((true_dist<0)&&(show_err==0))
            disp('Warning!!! GHT Distance is less than 0');
            show_err = 1;
        end           
    end
    disp(['No of real GHT calculation = ',num2str(ght_count),' from ',num2str(num_cand)]);
    list(lc+1:end,:) = [];    
    list = sortrows(list); 
    lcount = [num_cand bc1 bc2 lc ];  
    disp(lcount);
end    
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
function [list lcount]= ComputeGHT_AllMotif(cand, peaks, pic)
    global s1 s2 gap1 gap2 th_min_blk;
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Compute GHT on Candidate %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    num_cand = size(cand,1);
    lc = 0; bc1=0; bc2=0; show_err=0;
    list = zeros(num_cand,6);
    for i=1:num_cand
        a=cand(i,1);
        b=cand(i,2);
        if ((a==0)||(b==0)),      continue;       end
        x1 = peaks(a,1);
        y1 = peaks(a,2);
        x2 = peaks(b,1);
        y2 = peaks(b,2);
        if ((peaks(a,3) <th_min_blk) || (peaks(b,3) <th_min_blk))
            bc2 = bc2+1;
            continue;
        end
        if ((abs(x1-x2)<=gap1)&&(abs(y1-y2)<=gap2))
            bc1 = bc1+1;
            continue;
        end
        
        true_dist = ght3(pic(x1:x1+s1-1, y1:y1+s2-1) , pic(x2:x2+s1-1,y2:y2+s2-1), peaks(a,3), peaks(b,3));
%        true_dist = ght3(pic(x1:x1+s1-1, y1:y1+s2-1) , pic(x2:x2+s1-1,y2:y2+s2-1));
        true_dist = round(true_dist);
        if((true_dist<0)&&(show_err==0))
            disp('Warning!!! GHT Distance is less than 0');
            show_err = 1;
        end
        lc = lc+1;
        
        % % list => BSF, x1, y1, x2, y2, #hit
        list(lc,:) = [true_dist x1 y1 x2 y2 cand(i,3)];    
    end
    list(lc+1:end,:) = [];    
    list = sortrows(list); 
    lcount = [num_cand bc1 bc2 lc ];  
    disp(lcount);
end    
