function  HSig  = Create_HashSignature(ds_k)    
    global pic peaks;
    HSig = Create_HashSignature1(pic, peaks, ds_k);    


%%
function  HSig  = Create_HashSignature1(pic, peaks, ds_k)    
    
    global s1 s2 sr1 sr2;
    k=ds_k;
	sn1 = ceil(s1/k)*k;  sn2 = ceil(s2/k)*k; 
    ds1 = ceil(sn1/k);   ds2=ceil(sn2/k);  
    n_rect = size(peaks,1);
    HSig = false(n_rect, ds1*ds2);

    for ind = 1:size(peaks,1)
        tmp = false(ds1,ds2);
        im  = false(sn1,sn2);
        im(1:s1,1:s2) = pic(peaks(ind,1):peaks(ind,1)+s1-1, peaks(ind,2):peaks(ind,2)+s2-1);
        for i=1:k
           for j=1:k
              %tmp = tmp | im(i:k:min(sn1,ds1*k+i-1),j:k:min(sn2,ds2*k+j-1));
              tmp = tmp + im(i:k:min(sn1,ds1*k+i-1),j:k:min(sn2,ds2*k+j-1));              
           end
        end
        tmp = logical(round(tmp/(k*k/2)));        
        HSig(ind,:) = reshape(tmp, [1 ds1*ds2 ]);
    end

%%
function  HSig  = Create_HashSignature2(pic, peaks, ds_k)
    
    global s1 s2 sr1 sr2;
    k=ds_k;
	sn1 = ceil(s1/k)*k;  sn2 = ceil(s2/k)*k; 
    ds1 = ceil(sn1/k);   ds2=ceil(sn2/k);  
    half1 = round(ds1/2);
    half2 = round(ds2/2);
    n_rect = size(peaks,1);
    HSig = false(n_rect, ds1*ds2);
    box = false(2*ds1, 2*ds2);
    for ind = 1:size(peaks,1)
        im   = false(sn1,sn2);
        tmp  = false(ds1,ds2);
        im(1:s1,1:s2) = pic(peaks(ind,1):peaks(ind,1)+s1-1, peaks(ind,2):peaks(ind,2)+s2-1);
        for i=1:k
           for j=1:k
              tmp = tmp | im(i:k:min(sn1,ds1*k+i-1),j:k:min(sn2,ds2*k+j-1));
           end
        end
        [X Y] = find(tmp);
        cx=ceil(mean(X)); cy=ceil(mean(Y));
        box(half1+1:half1+ds1, half2+1:half2+ds2) = tmp;
        
        %%
        im2 = box(cx:cx+ds1-1, cy:cy+ds2-1);
        [X Y] = find(im2);
        cx2=ceil(mean(X)); cy2=ceil(mean(Y));
%        disp([cx cy cx2 cy2]);
        %%
        
        HSig(ind,:) = reshape(box(cx:cx+ds1-1, cy:cy+ds2-1), [1 ds1*ds2 ]);
    end
