%% Try to find Peaks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
function [peaks BSum] = FindPeaksAndSum(pic,s1,s2,th_min_blk)
       %%global BSum;
       t=cputime;
    
     % in case, i=1
       BSum = ComputeAllSum3(pic,s1,s2);
   
%     % by experiment use smaller box give better result
%     i=2;    
%     BSum = ComputeAllSum3(pic,ceil(s1/i),ceil(s2/i));
% %RBSum=BSum(:,end:-1:1); figure(1); surf(RBSum);
%      
%     [sp1 sp2] = size(pic);
%     [sb1 sb2] = size(BSum);
%     maxx = sp1 - s1 + 1;
%     maxy = sp2 - s2 + 1;
%     BSum(1:ceil((sb1-maxx)/2),:)=[];
%     BSum(maxx+1:end,:)=[];
%     BSum(:,1:ceil((sb2-maxy)/2))=[];
%     BSum(:,maxy+1:end)=[];
%     th_min_blk = ceil(th_min_blk/ i);    
    disp([' => ComputeAllSum: ',num2str(cputime-t),' sec']);
    
    t=cputime;
    LocalM = LocatePeaks(BSum, th_min_blk);
    disp([' => LocatePeaks: ',num2str(cputime-t),' sec']);
    [LMx LMy] = find(LocalM);
    peaks = [LMx  LMy  BSum(LocalM>0)];    
end

function BSum = ComputeAllSum3(pic,s1,s2)
    %%global pic BSum;
%Linear Time 2D Summation
    [sp1 sp2] = size(pic);
    maxx = sp1 - s1 +1;
    maxy = sp2 - s2 +1;
    ASum = zeros( sp1, maxy);
    BSum = zeros(maxx, maxy);
    
    %Create ASum
    for x=1: sp1
        tmp = sum(pic(x, 1:s2));
        ASum(x,1) = tmp;
        for y=2:maxy            
            tmp = tmp + pic(x,y-1+s2) - pic(x,y-1);
            ASum(x,y) = tmp;
        end
    end
    
    %Create BSum
    for y=1: maxy
        tmp = sum(ASum(1:s1, y));
        BSum(1,y) = tmp;
        for x=2:maxx
            tmp = tmp + ASum(x-1+s1, y) - ASum(x-1, y);
            BSum(x,y) = tmp;
        end
    end     
end
    
function d = LocatePeaks(a, thres)
    if (nargin < 2),    thres = 0;  end;
      b = false(size(a));      
      b(2:end-1, 2:end-1) =  ...
        ( a(2:end-1, 2:end-1)>= a(1:end-2, 1:end-2) & ...
          a(2:end-1, 2:end-1)>= a(1:end-2, 2:end-1) & ...
          a(2:end-1, 2:end-1)>= a(1:end-2, 3:end  ) & ...
          a(2:end-1, 2:end-1)>= a(2:end-1, 1:end-2) & ...
          a(2:end-1, 2:end-1)> a(2:end-1, 3:end  ) & ...
          a(2:end-1, 2:end-1)> a(3:end  , 1:end-2) & ...
          a(2:end-1, 2:end-1)> a(3:end  , 2:end-1) & ...
          a(2:end-1, 2:end-1)> a(3:end  , 3:end  )) ;    
    d = (a>thres)&(b);
end
    
     

    


    