%%    
function [t_all t_ght t_prep n_result n_ght max_buck result_list] = Run_Approx_Alg4_x()
    global pic_all pic;
    global s1 s2 sr1 sr2 maxx maxy k ds_k n_round mask th_min_blk gap1 gap2 boundary;    
    global pic BSum peaks;
    
    pic = pic_all;
    [so1 so2] = size(pic);
    maxx = ceil(so1/k); maxy=ceil(so2/k);   
    sr1 = maxx-s1+1;    sr2 = maxy-s2+1;
    ds1 = ceil(s1/ds_k);ds2 = ceil(s2/ds_k);   
    gap1 = s1; gap2 = s2;
    tic; t_start = cputime; t_prep=0; t_ght=0; t_all=0;
        
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% == Start Here == %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    t=cputime;
    [peaks BSum] = FindPeaksAndSum(pic,s1,s2,th_min_blk);    
    disp(['Find Peaks & Sum : ',num2str(cputime-t),' sec','( Mem: ',num2str(memUsed),' MB)']);
    
    t=cputime;
     peaks = AlignCenter3(peaks, pic,s1,s2,BSum);     
    disp(['AlignCenter : ',num2str(cputime-t),' sec','( Mem: ',num2str(memUsed),' MB)']);

    t=cputime;
    HSig  = Create_HashSignature(ds_k);
    disp(['Create Hash Sig : ',num2str(cputime-t),' sec','( Mem: ',num2str(memUsed),' MB)']);  
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% == RANDOM MASK == %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    t=cputime;   
    pm = mask/100;
    nbit_mask = ceil(pm*ds1*ds2);
    [candidate max_buck]= RandomMask4x(HSig, peaks, n_round, nbit_mask, th_min_blk);    
    %disp([num2str(size(candidate,1)),' pairs are found (',num2str(pm),' mask, ',num2str(n_round),' rounds)' ]);
       
    t_prep = cputime - t_start;
    disp(['Random Mask ',num2str(sr1*sr2),' rectangles :',num2str(cputime-t),' sec','( Mem: ',num2str(memUsed),' MB)']);
    disp(['--- Finish Preprocessing in ',num2str(t_prep),' sec ---','( Mem: ',num2str(memUsed),' MB)']);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% == Merge list & Find non-duplicated, matched pair == %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    candidate = sortrows(candidate);
    [cand_sorted cx1] = unique(candidate,'rows','first');
    [cand_sorted cx2] = unique(candidate,'rows','last');
    cand = [cand_sorted cx2-cx1+1];
    cand = sortrows(cand,3);
    cand = cand(end:-1:1,:);   
    disp([num2str(size(cand,1)),' non-duplicated pairs found','( Mem: ',num2str(memUsed),' MB)']);        

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% == Find GHT of all candidate pair == %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    n_ght = size(cand,1);
    t_start = cputime;
    disp('Now Running GHT ... ');        
    [list lcount] = ComputeGHT2(cand, peaks, pic);
    t_ght = cputime - t_start;    
    disp(['Compute GHT of ',num2str(size(cand,1)),' pairs : ',num2str(t_ght),' sec ---']);
    t_all = t_prep + t_ght;    

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% == Remove pair in same location == %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
    disp(['', num2str(size(list,1)),' pairs are found','( Mem: ',num2str(memUsed),' MB)']);
    list2 = NonOverlap(100,list);
    n_result = size(list2,1);
    disp(['Get top ', num2str(size(list2,1)),' non-overlap pairs','( Mem: ',num2str(memUsed),' MB)']);
    result_list = list2;
    disp(['---- Finish All Computation in ',num2str(t_all),' sec -----','( Mem: ',num2str(memUsed),' MB)']);    
    disp(result_list(1:min(10,size(result_list,1)),:));
    
   
    