function lb = ght_lb(im1,im2,sumIm1,sumIm2,ver)
    if (nargin < 3)
        sumIm1 = sum(sum(im1));        
        sumIm2 = sum(sum(im2));        
    end    
    if (nargin < 5)
        ver = 1;
    end
    sig1x = remove_tail(sum(im1,2));
    sig1y = remove_tail(sum(im1,1));
    sig2x = remove_tail(sum(im2,2));
    sig2y = remove_tail(sum(im2,1));
            
    lby = lb_row(sig1y,sig2y,sumIm1,ver);
    lbx = lb_col(sig1x,sig2x,sumIm1,ver);    
    match_score = max(lby,lbx);
    lb_mue = sumIm1 - max(lby,lbx);    % normal LB_MUE
% % lb = lb_mue;
    lb = DistM3(lb_mue, sumIm1, sumIm2,0);    
end

function a =remove_tail(a)
    onesA = find(a);
    if (~isempty(onesA))
        a = a(onesA(1):onesA(end));
    end    
end

function lb = lb_col(a,b,sumA,ver)
    lb = lb_row(a',b',sumA,ver);
end

function lb = lb_row(a,b,sumA,ver) 
    if (ver == 0)   
        lb = lb_0_old(a,b,sumA);
    elseif (ver == 1)
        lb = lb_1_qiang(a,b,sumA);
    else
        lb = lb_2_new(a,b,sumA);
    end
end
